authentication/urls.py
from django.urls import path

from authentication.views import user
from authentication.views.user import update_profile

app_name = 'authentication'
urlpatterns = [
    path('update/<int:pk>', update_profile.as_view(), name='update'),
    path('login/', user.login, name='login'),
    path('logout/', user.logout, name='logout'),
    path('register/', user.register, name='register'),
    path('checkcart/', user.check_cart, name='check_cart'),
    path('<str:username>/', user.userinfo, name='user'),
]

main/urls.py
from django.urls import path
from main.views import ai_solutions
from main.views.consulting import HomeView
from main.views.consulting import PostDetail
from main.views.consulting import CreatePost
from main.views.consulting import AddComment,shopping_carts
from main.views.consulting import Experts
from main.views.consulting import LikeView
from main.views.consulting import ReverseView
from main.views.consulting import SortedView
from main.views.consulting import HotView
from main.views.consulting import MyShare
from main.views.plant import my_plants
from main.views.plant import add_plants, manage_plants
from main.views.plant import diagnoseView
from main.views.plant import delete_plants

app_name = 'main'
urlpatterns = [
    path('', ai_solutions.index, name='index'),
    path('aisolutions/<int:page>/', ai_solutions.ai_solutions, name='ai_solutions'),
    path('aisolutions/smartcurtain/<int:page>/', ai_solutions.smart_curtain, name='smart_curtain'),
    path('aisolutions/virtualrealityforesttherapy/<int:page>/', ai_solutions.virtual_reality_forest_therapy, name='virtual_reality_forest_therapy'),
    path('aisolutions/virtualrealityforesttherapy/digital_twin/', ai_solutions.digital_twin, name='digital_twin'),
    path('aisolutions/virtualrealityforesttherapy/vr_detail/', ai_solutions.vr_detail, name='vr_detail'),


    #path('', HomeView.as_view(), name='index'),
    path('consulting/', HomeView.as_view(), name='consulting'),
    path('consulting/my_share', MyShare.as_view(), name='my_share'),
    path('consulting/<int:pk>/', PostDetail.as_view(), name='post_detail'),
    path('consulting/creatingPost/', CreatePost.as_view(), name='create_post'),
    path('consulting/<int:pk>/commentPost/', AddComment.as_view(), name='add_comment'),
    path('consulting/experts', Experts.as_view(), name='experts'),
    path('like/<int:pk>', LikeView, name='like_post'),
    path('consulting/', ReverseView.as_view(), name='reverse_post'),
    path('consulting/sorted/', SortedView.as_view(), name='sorted_post'),
    path('consulting/hot/', HotView.as_view(), name='hot_post'),
    path('my_plants/', my_plants.as_view(), name='my_plants'),
    path('manage_plants/<int:pk>/', manage_plants.as_view(), name='manage_plants'),
    path('add_plants/', add_plants.as_view(), name='add_plants'),
    path('diagnose/<int:pk>', diagnoseView, name='diagnose'),
    path('delete_plants/<int:pk>', delete_plants.as_view(), name='delete_plants'),
    path('shopping_carts/', shopping_carts.as_view(), name='shopping_carts'),
]

mysite/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
                path('', include('main.urls')),
                path('authentication/', include('authentication.urls')),
                path('admin/', admin.site.urls),
              ] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

main/views/ai_solutions.py
from django.shortcuts import render

import logging

from authentication.utils.check_login_state import check_login
from main.utils.ai_solutions_utils import *

logger = logging.getLogger(__name__)


def index(request):
    return render(request, 'main/index.html')


#@check_login
def ai_solutions(request, page):
    product_list, promotion_product_list, first_promotion_product, pagination = get_product(page)

    return render(request, 'main/ai_solutions.html',
                  {'product_list': product_list, 'promotion_product_list': promotion_product_list,
                   'first_promotion_product': first_promotion_product,
                   'promotion_product_num': range(len(promotion_product_list)),
                   'pagination': pagination})


#@check_login
def smart_curtain(request, page):
    product_list, promotion_product_list, first_promotion_product, pagination = get_product(page)
    load_animation = False
    if page == 1:
        load_animation = True

    return render(request, 'main/smart_curtain.html',
                  {'product_list': product_list,
                   'pagination': pagination,
                   'load_animation': load_animation})


#@check_login
def virtual_reality_forest_therapy(request, page):
    product_list, VR_product_list, first_promotion_product, pagination = get_VR_FT(page)
    
    return render(request, 'main/virtual_reality_forest_therapy.html',
                  {'product_list': product_list, 'VR_product_list': VR_product_list,
                   'first_promotion_product': first_promotion_product,
                   'promotion_product_num': range(len(VR_product_list)),
                   'pagination': pagination})

def digital_twin(request):
    return render(request,'main/VRFT_digital_twin.html')

def vr_detail(request):
    return render(request,'main/vr_detail.html')

main/views/consulting.py
import collections
from unicodedata import name
from attr import fields
from django import forms
from django.core.mail import send_mail
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, redirect, render
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView,DeleteView,CreateView
import logging
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from authentication.utils.check_login_state import check_login
from main.serializer import CartItemSerializer
from main.utils.ai_solutions_utils import *
from main.models import Cart, CartItem, Post
from main.models import Comment
from authentication.models import User
from rest_framework.views import APIView
from rest_framework.response import Response
#from authentication.form import CommentForm

logger = logging.getLogger(__name__)
def index(request):
    return render(request, 'main/consulting.html', {})

sort=0 
"""
0: regular 
1: reverse
2: hot
"""


class HomeView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(HomeView, self).get_context_data(**kwargs)
        context['object_list'] = context['object_list'][::-1]
        print(context)
        return context
        
    
#@method_decorator(check_login, name='dispatch')
class PostDetail(DeleteView):
    model = Post
    template_name = 'main/post_detail.html'

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        
        self.p = get_object_or_404(Post, id=self.kwargs['pk'])
        if not self.p.author:
            self.p.author = self.user
            # send post to our email
            send_mail(
                "Post update",
                f"Hello, \n\nThe user: {self.p.author.name}({self.p.author.email}) has shared a post.\nPost title: {self.p.title}\nPost content: {self.p.content}\nPlease check the detail at Smartplanting.net as admin.\n\nThank you!",
                "rundi.liu26@gmail.com",
                ["rundi.liu26@visionx.org"]
            )
        self.p.save()

        Comment.objects.filter(name=None).update(name=self.user.name)
        
        self.p.post_views = self.p.post_views + 1
        self.p.save()
        return super(PostDetail, self).dispatch(request, *args, **kwargs)
    
    def get_context_data(self, **kwargs):
        context = super(PostDetail, self).get_context_data(**kwargs)
        ob = get_object_or_404(Post, id=self.kwargs['pk'])
        num = ob.num_likes
        context["num_likes"] = num
        return context

#@method_decorator(check_login, name='dispatch')
class CreatePost(CreateView):
    model = Post
    template_name: str = 'main/create_post.html' # same w render(request, teplate_name)
    fields = ['title', 'image', 'content']

    def dispatch(self, request, *args, **kwargs):
        return super(CreatePost, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        return context

#@method_decorator(check_login, name='dispatch')
class AddComment(CreateView):
    model = Comment
    #form_class = CommentForm
    template_name = 'main/add_comment.html'
    fields = ['post', 'content']

    def get_context_data(self, **kwargs):
        context = super(AddComment, self).get_context_data(**kwargs)
        ob = get_object_or_404(Post, id=self.kwargs['pk'])
        context["form"].fields["post"].queryset = Post.objects.filter(title=ob.title, author=ob.author)
        return context
    
class Experts(ListView):
    model = Post
    template_name = 'main/experts.html'
    fields = '__all__'

class MyShare(ListView):
    model = Post
    template_name = 'main/my_share.html'

@check_login
def LikeView(request, pk):
    post = get_object_or_404(Post, id=request.POST.get('post_id')) # grab in detail html
    try:
        user = get_object_or_404(User, pk=request.session['user_id'])
    except:
        user = User.objects.get(name='Guest')
    if user not in post.likes.all():
        post.likes.add(user)
    else:
        post.likes.remove(user)
    return HttpResponseRedirect(reverse('main:post_detail', args=[str(pk)]))


class SortedView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(SortedView, self).get_context_data(**kwargs)
        return context

class ReverseView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(ReverseView, self).get_context_data(**kwargs)
        new_context = context
        new_context['object_list'] = new_context['object_list'].order_by('-date_added')
        return new_context

class HotView(ListView):
    model = Post
    template_name = 'main/consulting.html'

    def get_context_data(self, **kwargs):
        context = super(HotView, self).get_context_data(**kwargs)
        hot_context = context
        hot_context['object_list'] = hot_context['object_list'].order_by('-post_views')
        return hot_context

class CartView(APIView):
    
    def get(self, request):
        user = request.user
        cart = Cart.objects.filter(user=user,ordered=False).first()
        queryset = CartItem.objects.filter(cart=cart)
        serializer = CartItemSerializer(queryset, many=True)
        return Response(serializer.data)

    def post(self, request):
        data = request.data
        user = request.user
        cart, _ = Cart.objects.get_or_create(user=user, ordered=False)
        product = Product.objects.get(id=data.get('product'))
        price = product.price
        quantity = data.get('quantity')
        cart_items = CartItem(cart=cart, user=user, product=product, price=price, quantity=quantity)
        cart_items.save()

        cart_items = CartItem.objects.filter(user=user, cart=cart.id)
        cart.total_price = sum([i for i in cart_items])
        cart.save()

        return Response({'success': 'Items Added'})

    def put(self, request):
        data = request.data
        cart_item = CartItem.objects.get(id=data.get('id'))
        quantity = data.get('quantity')
        cart_item.quantity += quantity
        cart_item.save()
        return Response({'success': 'Items Updated'})

    def delete(self, request):
        user = request.user
        data = request.data
        cart_item = CartItem.objects.get(id=data.get('id'))
        cart_item.delete()
        cart = Cart.objects.filter(user=user, ordered=False).first()
        queryset = CartItem.objects.filter(cart=cart)
        serialier = CartItemSerializer(queryset, many=True)
        return Response(serialier.data)

@method_decorator(check_login, name='dispatch')
class shopping_carts(ListView):
    model = CartItem
    template_name = 'main/shopping_carts.html'

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        return super(shopping_carts, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = CartItem.objects.order_by('id')
        return super(shopping_carts, self).get_context_data(**kwargs)

main/views/plant.py
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse, reverse_lazy
from django.views.generic import ListView,UpdateView,CreateView,DeleteView
from django.core.mail import send_mail
from main.models import Plant
from authentication.models import User

class my_plants(ListView):
    model = Plant
    template_name = 'main/my_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def dispatch(self, request, *args, **kwargs):
        try:
            self.user = get_object_or_404(User, pk=request.session['user_id'])
        except:
            self.user = user = User.objects.get(name='Guest')
        Plant.objects.filter(owner=None).update(owner=self.user)
        return super(my_plants, self).dispatch(request, *args, **kwargs)

class add_plants(CreateView):
    model = Plant
    template_name = 'main/add_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(add_plants, self).get_context_data(**kwargs)


class delete_plants(DeleteView):
    model = Plant
    template_name = 'main/delete_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']
    success_url = reverse_lazy('main:my_plants')

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(delete_plants, self).get_context_data(**kwargs)

class manage_plants(UpdateView):
    model = Plant
    template_name = 'main/manage_plants.html'
    fields = ['name', 'category', 'age', 'image', 'health']

    def get_context_data(self, **kwargs):
        kwargs['object_list'] = Plant.objects.order_by('id')
        return super(manage_plants, self).get_context_data(**kwargs)

def diagnoseView(request, pk):
    plant = get_object_or_404(Plant, pk=pk)
    plant.diagnose = True
    plant.save()
    send_mail(
        "Health Diagnosis",
        f"Hello, \n\nThe user:{plant.owner.name}({plant.owner.email}) has requested the health diagnosis for '{plant.name}',\nPlease check the detail at Smartplanting.net as admin.\n\nThank you!",
        "rundi.liu26@gmail.com",
        ["rundi.liu26@visionx.org"]
    )
    return HttpResponseRedirect(reverse('main:my_plants'))

main/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
            integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
            crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/animejs@3.2.1/lib/anime.min.js"
            integrity="sha256-XL2inqUJaslATFnHdJOi9GfQ60on8Wx1C2H8DYiN1xY=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/waypoints/4.0.1/noframework.waypoints.min.js"
            integrity="sha512-fHXRw0CXruAoINU11+hgqYvY/PcsOWzmj0QmcSOtjlJcqITbPyypc8cYpidjPurWpCnlB8VKfRwx6PIpASCUkQ=="
            crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <script src="https://kit.fontawesome.com/1fb9f38c90.js" crossorigin="anonymous"></script>
    <link rel="stylesheet" type="text/css" href="{% static 'css/base.css' %}"/>
    <script src="{% static 'js/animation.js' %}"></script>
    <script src="{% static 'js/utils.js' %}"></script>
    {% block resource %}{% endblock %}
    <title>{% block title %}SmartPlanting{% endblock %}</title>
    {% block head_script %}{% endblock %}
</head>

<body>
<div class="header">
    <nav class="navbar-expand-lg navbar navbar-dark" style="background-color: #114934;">
        <div class="container-fluid base-container">
            {% block nav_brand %}{% endblock %}
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    {% block nav_items %}{% endblock %}
                </ul>
                <ul class="nav justify-content-end icon-group">
                    <li class="nav-item">
                        <a class="nav-link" href="#" role="button"><i
                                class="fas fa-search"></i></a>
                    </li>
                    {% if request.session.user_id %}
                        <li class="nav-item dropdown">
                            <a class="nav-link" data-bs-toggle="dropdown" href="#" role="button"
                               data-bs-display="static"
                               aria-expanded="false"><i
                                    class="fas fa-user"></i></a>
                            <ul class="dropdown-menu dropdown-menu-end dropdown-menu-lg-start">
                                <li><a class="dropdown-header"
                                       href="{% url 'authentication:user'  request.session.username %}">{{ request.session.username }}</a>
                                </li>
                                <li>
                                    <hr class="dropdown-divider">
                                </li>
                                <li><a class="dropdown-item" href="#">My order</a></li>
                                <li><a class="dropdown-item" href="{% url 'main:my_share' %}">My share</a></li>
                                <li>
                                    <hr class="dropdown-divider">
                                </li>
                                <li><a class="dropdown-item" href="{% url 'authentication:logout' %}">Log out</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link" data-bs-toggle="dropdown" href="#" role="button"
                               data-bs-display="static"
                               aria-expanded="false"><i class="fas fa-shopping-bag"></i></a>
                            <ul class="dropdown-menu dropdown-menu-end dropdown-menu-lg-start cart" id="cart">
                                <li><span class="dropdown-item"><i class="fas fa-shopping-cart"></i></span></li>
                                
                                <li><a class="dropdown-item" href="#">Shopping Cart</a></li>

                                {#                                <li><span class="dropdown-header"><i class="fas fa-shopping-cart"></i> Cart</span></li>#}
                                {#                                <li>#}
                                {#                                    <hr class="dropdown-divider">#}
                                {#                                </li>#}
                                {#                                <li><p class="dropdown-item">Curtain x1</p></li>#}
                                {#                                <li>#}
                                {#                                    <hr class="dropdown-divider">#}
                                {#                                </li>#}
                                {#                                <li><a class="dropdown-item" href="#">Go to Cart</a></li>#}
                            </ul>
                        </li>
                    {% else %}
                        <li class="nav-item">
                            <a class="nav-link" href="{% url 'authentication:login' %}"><i
                                    class="fas fa-user"></i></a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{% url 'authentication:login' %}"><i
                                    class="fas fa-shopping-bag"></i></a>
                        </li>
                    {% endif %}
                </ul>
            </div>
        </div>
    </nav>
</div>
<div class="content">
    {% block content %}{% endblock %}
    <div class="footer" id="footer">
        <div class="container-fluid base-container">
            <div class="row">
                <div class="col-lg footer-div footer-div-left footer-div-from-up">
                    <div class="footer-text">
                        <h1>Get In Touch</h1>
                        <p>
                            250 W Tasman Dr<br/>
                            San Jose, CA 95134<br/>
                            Phone: +1 408-418-6388<br/>
                            Fax: +1775 240 9793<br/>
                            Email: Support@visionx.org<br/>
                        </p>
                    </div>
                </div>
                <div class="col-lg footer-div footer-div-from-down">
                    <div class="footer-text">
                        <h1>About Us</h1>
                        <p>
                            Smart home is a cross-industry which focus on plant care.
                            Our company has designed and developed a set of artificial intelligence to automatically
                            identify
                            each Flowers and trees and their growth status, combined with real-time geographic and
                            climate
                            conditions, using big data analysis and timely prediction and guidance on the healthy growth
                            conditions of flowers and trees.
                        </p>
                    </div>
                </div>
                <div class="col-lg footer-div footer-div-right footer-div-from-up">
                    <div class="footer-text">
                        <h1>Join Us Now!</h1>
                        <p>
                            We are active on Twitter, <br/>
                            Telegram, Medium, Reddit, <br/>
                            YouTube, Instagram, <br/>
                            Facebook, LinkedIn, GitHub <br/>
                            and Coinmarketcap.
                        </p>
                        <div class="social-media-icon-group">
                            <ul class="social-media-icon-group-ul">
                                <li><a href="#"><i class="fab fa-twitter"></i></a></li>
                                <li><a href="#"><i class="fab fa-telegram"></i></a></li>
                                <li><a href="#"><i class="fab fa-medium"></i></a></li>
                                <li><a href="#"><i class="fab fa-reddit-alien"></i></a></li>
                                <li><a href="#"><i class="fab fa-youtube"></i></a></li>
                                <li><a href="#"><i class="fab fa-instagram"></i></a></li>
                                <li><a href="#"><i class="fab fa-github"></i></a></li>
                                <li><a href="#">
                                    <img src="{% static 'img/coinmarketcap.svg' %}" class="filter-blue"/>
                                </a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="footer-copyright" id="footer_copyright">
        <div class="container-fluid base-container">
            <div class="row">
                <div class="col-lg footer-copyright-from-left">
                    <p>Copyright © 2020 Visionx Llc</p>
                </div>
                <div class="col-lg footer-copyright-from-right">
                    <p>Powered By <a href="https://www.visionx.org">Visionx Llc</a></p>
                </div>
            </div>
        </div>
    </div>
</div>
{% block script %}{% endblock %}
</body>
</html>